<?php

namespace WePublish\CDN_YES\Inc;

use WP_Http;
use WP_Error;
use WePublish\CDN_YES\Inc\Service\Refresh;

/**
 * 发送HTTP请求
 *
 * @param string $url
 * @param string $method
 *
 * @return WP_Error|string
 */
function request( string $url, string $method = 'GET' ): WP_Error|string {
	$http = new WP_Http();

	// 统一去除字符串转义，否则数据无法被 JSON 解析
	foreach ( $method == 'post' ?: array() as $k => $v ) {
		$post[ $k ] = stripcslashes( $v );
	}

	return $http->request(
		$url,
		array(
			'method'      => $method,
			'body'        => $post ?? null,
			'timeout'     => 20,
			'httpversion' => '1.1',
			'sslverify'   => false
		)
	)['body'];
}

/**
 * 静态加速
 *
 * @return void
 */
function cdn_static(): void {
	add_action( 'template_redirect', function () {
		ob_start( function ( $content ) {
			$regex = '#(?<=[(\"\'])(?:' . quotemeta( home_url() ) . ')?/(?:((?:wp-content|wp-includes)[^\"\')]+\.(css|js)[^\"\')]+))(?=[\"\')])#';

			return preg_replace_callback( $regex, function ( &$asset ) {
				return 'https://public.cdn.wepublish.cn/' . $asset[0];
			}, $content );

		} );
	} );
}
